package ijp.assignment1.langen;

import java.util.ArrayList;
import java.util.List;



/**
 * A simple template driven language generator. Used in IJP assignment 
 * 1 to generate language for the ChatBots 
 * 
 * @author Judy Robertson, Nigel Goddard
 */
public class TemplateLanguageGenerator implements LanguageGenerator {
    
	
	/**
	 * A collection of sentence templates which this language generator can use
	 */
	private ArrayList <SentenceTemplate> sentenceList  = new ArrayList <SentenceTemplate> ();

	

	/**
	 * Creates a TemplateLanguageGenerator, sets up the sentence templates,
     * 
	 *
	 */
	public TemplateLanguageGenerator() {
		populateSentences();
		
	}

	/**
	 * Sets up the sentence templates which can be used by this language generator
	 *
	 */
	private void populateSentences() {
		
	}

	

	/**
	 * Generates a sentence using a randomly chosen template
	 *
     * @return A string containing the sentence
	 */

	public String generateSentence() {
		
	}
	
	/**
	 * Expands the template into a full sentence. The templates are strings
	 * consisting of canned text and instructions to generate more text. Canned
	 * segments and instructions are delimited by "%".
	 *
     * @param sentenceTemplate The template which will be expanded
	 * 
     * @return A string containing the sentence expanded out of the template
	 */
    
	private String expandTemplate(String sentenceTemplate) {
		
	}

	
    
    /**
     * Use key word matching to generate a canned response to the specified
     * comment.
     * 
     * @param remark The input which we must respond to
     * 
     * @return A string containing a reply to the specified remark
     */
    private String keyWordMatch(String remark){
       
    }

	/**
	 * Parse the input remark, and find a key word which we can respond to
     * 
	 * @param remark The input to be parsed
     * 
	 * @return A keyword from the input which will be used in the reply
	 */
    
	private String findKeyWord(String remark) {
		
	}

	/**
	 * Generate a reply to the specified remark. The reply is related to the 
     * input remark in the vague sense that it contains a word relating to one 
     * of the words in the input
     * 
	 * @param remark The remark which must be responded to
     * 
	 * @return A string containing a response to the specified remark
	 */
    
	public String generateReply(String remark) {
		
	}
    
   

}
