package ijp.assignment1.chat;




/**
 * A class representing a digital persona known as a chat bot. 
 * The chat bot can start conversations and reply to remarks. 
 * <p> Used in IJP assignments 1 and 2.</p>
 * 
 * @author Judy Robertson, Nigel Goddard
 */
public class ChatBot {

	/**
	 * The name of the character
	 */
    
	private String name;

	/**
	 * A textual description of the appearance and personality of this character
	 */
	private String description;

	

	/**
	 * Create a ChatBot, initialise the language generator
	 *
	 */

	public ChatBot() {
		
	}

	/**
	 * Initiate a conversation about any topic. Generate a starting sentence
     * 
	 * @return A sentence with which to start a conversation
	 */

	public String startConversation() {

	
	}

	/**
	 * Generate a response to the specified remark
     * 
	 * @param remark The comment which must be responded to
     * 
	 * @return A sentence which represents a reply to the specified remark
	 */
	public String reply(String remark) {

	
	}

	

	/**
	 * Gets the textual description of what the chat bot looks like and 
     * its personality
     * 
	 * @return A textual description of the chat bot
	 */
	public String getDescription() {
	
	}

	/**
	 * Gets the name of the chat bot
     * 
	 * @return The name of this digital persona
	 */
	public String getName() {
	
	}

	/**
	 * Sets up the textual description of the chat bot's appearance and personality
     * 
	 * @param string The textual description of the bot
	 */
	public void setDescription(String string) {
	
	}

	/**
	 * Sets up the name of this digital persona
     * 
	 * @param string The name of the bot
	 */
	public void setName(String string) {
		
	}

}
